#include "StringGenerator.hpp"

using namespace std;

namespace domain
{
  StringGenerator::StringGenerator() : StringGenerator(new string("temp"))
  {
  }
  StringGenerator::StringGenerator(string* baseName) : baseName(baseName), ct(0)
  {
  }
  StringGenerator::~StringGenerator()
  {
    delete baseName;
  }
  
  string* StringGenerator::get()
  {
    string* s = new string(*baseName);
    s->append(to_string(ct));
    ++ct;
    return s;
  }
  string* StringGenerator::previous()
  {
    --ct;
    string* s = get();
    ++ct;
    return s;
  }
  
  
  StringGeneratorGenerator::StringGeneratorGenerator() : StringGeneratorGenerator(new string("temp"))
  {
  }
  StringGeneratorGenerator::StringGeneratorGenerator(string* baseName) : baseName(baseName), ct(0), prev(NULL)
  {
  }
  StringGeneratorGenerator::~StringGeneratorGenerator()
  {
    delete baseName;
  }
  
  StringGenerator* StringGeneratorGenerator::get()
  {
    string* s = new string(*baseName);
    s->append(to_string(ct));
    ++ct;
    prev = new StringGenerator(s);
    return prev;
  }
  
  StringGenerator* StringGeneratorGenerator::previous()
  {
    return prev;
  }


} // namespace domain
