#include <iostream>
#include <sstream>
#include <algorithm>

#include "LogicProgramOptimization.hpp"

#include "../asp-domain/safetyCharacterization.hpp"

using namespace std;

LogicProgramOptimizationTuple::LogicProgramOptimizationTuple() {
}

LogicProgramOptimizationTuple::~LogicProgramOptimizationTuple() {
}

bool LogicProgramOptimizationTuple::operator<(const Tuple &/*other*/) const
{
	return true; // TODO: not only in singleton containers
}

bool LogicProgramOptimizationTuple::operator==(const Tuple &/*other*/) const
{
	return true; // TODO
}

int LogicProgramOptimizationTuple::hash() const
{
	return -1; // TODO
}

LogicProgramOptimizationAlgorithm::LogicProgramOptimizationAlgorithm(LogicProgramProblem *problem)
	: AbstractHTDAlgorithm(problem)
{
	this->problem = problem;
	bodyPart_time = 0;
	extractBody_time = 0;
	bodyCreation_time = 0;
	tempPredCreation_time = 0;
	unsafe_time = 0;
	rest_time = 0;
	originalStatementsVars = NULL;
}

LogicProgramOptimizationAlgorithm::~LogicProgramOptimizationAlgorithm() {
	delete originalStatementsVars;
}

Solution *LogicProgramOptimizationAlgorithm::selectSolution(TupleSet */*tuples*/, const ExtendedHypertree */*root*/)
{
	return NULL;
}

/* OLD IMPLEMENTATION FROM TIMES WHEN I STILL HAD TRUST IN EXTENDEDHYPERTREE
TupleSet *LogicProgramOptimizationAlgorithm::evaluateNode(const ExtendedHypertree *node)
{
  if (problem->program->statementsSize() == 0) // initial call without statements.
  {
    TupleSet *ts = new TupleSet();
    this->addToTupleSet(new LogicProgramOptimizationTuple(), NULL, ts);
    return ts;
  }
  
  // first, make depth-first recursive calls. We want to do bottom-up traversal.
  LogicProgramOptimizationTuple* leftTempPred = NULL;
  LogicProgramOptimizationTuple* rightTempPred = NULL;
  if (node->firstChild() != NULL)
    leftTempPred = (LogicProgramOptimizationTuple *) evaluateNode(node->firstChild())->begin()->first;
  if (node->secondChild() != NULL)
    rightTempPred = (LogicProgramOptimizationTuple *) evaluateNode(node->secondChild())->begin()->first;
  
  
  // those body elements of the base rule that are in this node: (go in bodyPart)
  varset thisVars;
  for (VertexSet::iterator it = node->getVertices().begin(); it != node->getVertices().end(); ++it)
  {
    Variable* var = new Variable(new string(problem->getVertexName(*it)));
    thisVars.insert(var);
  }    
  vector<const BodyElement *>* bodyPart = problem->curStatement().selectBody(thisVars);
  for (varset::iterator it = thisVars.begin(); it != thisVars.end(); ++it)
    delete *it;

  // create new rule body:
  Body* body = new Body();
  for (vector<const BodyElement *>::iterator it = bodyPart->begin(); it != bodyPart->end(); ++it)
    body->add((*it)->clone());
  delete bodyPart;
  if (leftTempPred != NULL) // TODO SEGFAULT with dynamic_cast. consider node ONLY as Hypertree.
    body->add(leftTempPred->temporary);
  if (rightTempPred != NULL)
    body->add(rightTempPred->temporary);

  if (!node->isRoot())
  {
    VertexSet intersectionVertices;
    std::set_intersection(node->getVertices().begin(), node->getVertices().end(), node->parent()->getVertices().begin(), node->parent()->getVertices().end(), inserter(intersectionVertices, intersectionVertices.begin()));
    
    varset intersectionVars;
    vector<Term*>* tempPredTerms = new vector<Term*>();
    for (VertexSet::iterator it = intersectionVertices.begin(); it != intersectionVertices.end(); ++it)
    {
      Variable* var = new Variable(new string(problem->getVertexName(*it)));
      intersectionVars.insert(var);
      tempPredTerms->push_back(var);
    }
    
    // create temporary predicate:
    ClassicalLiteral* tempPred = new ClassicalLiteral(problem->gen->get(), false, false, new TermTuples(new vector<TermTuple *>(1, new TermTuple(tempPredTerms))));
    
    
    // deal with unsafe variables:
    SafetyCharacterization* safety;
    while(!(safety = body->safety())->unsafeVars().empty())
    {
      // for each unsafe var, create new Rule and add the safety predicate to the body: TODO: wouldn't it be more efficient to generate only one safety predicate for all unsafe variables?
      for (varset::iterator varit = safety->unsafeVars().begin(); varit != safety->unsafeVars().end(); ++varit)
      {
	vector<const BodyElement*>* safemakers = problem->curStatement().selectSafe(**varit);
	ClassicalLiteral* safetyPred = new ClassicalLiteral(&problem->gen->get()->append("_safe"), false, false, new TermTuples(new vector<TermTuple *>(1, new TermTuple(new vector<Term*>(1, new Variable(**varit))))));
	body->add(safetyPred);
	vector<BodyElement*>* bodyElements = new vector<BodyElement*>();
	for (vector<const BodyElement*>::iterator bit = safemakers->begin(); bit != safemakers->end(); ++bit)
		bodyElements->push_back((*bit)->clone());
	problem->createdProgram->push_back(new Rule(new Disjunction(new vector<ClassicalLiteral*>(1, safetyPred->clone())), new Body(bodyElements))); // TODO: new safety rule may be split up as well!!!
	delete safemakers;
      }
    }
    
    // make new rule:
    problem->createdProgram->push_back(new Rule(new Disjunction(new vector<ClassicalLiteral *>(1, tempPred->clone())), body));
    
    TupleSet *ts = new TupleSet();
    LogicProgramOptimizationTuple *t = new LogicProgramOptimizationTuple();
    t->temporary = tempPred;
    this->addToTupleSet(t, NULL, ts);
    return ts;
  }
  else // node is root node
  {
    // include variable-free body elements!
    vector<const BodyElement *>* nonVars = problem->curStatement().variableFreeBody();
    for (vector<const BodyElement *>::iterator it = nonVars->begin(); it != nonVars->end(); ++it)
      body->add((*it)->clone());
    delete nonVars;
    
    // since we are in head node, there are no unsafes in our body.
    problem->createdProgram->push_back(problem->curStatement().cloneHead(body));
    
    TupleSet *ts = new TupleSet();
    this->addToTupleSet(new LogicProgramOptimizationTuple(), NULL, ts);
    return ts;
  }
} */

#pragma GCC diagnostic ignored "-Wmaybe-uninitialized" // rootbeg, tmp_time
TupleSet *LogicProgramOptimizationAlgorithm::evaluateNode(const ExtendedHypertree *node)
{
  if (problem->program->statementsSize() == 0) // initial call without statements.
  {
    TupleSet *ts = new TupleSet();
    this->addToTupleSet(new LogicProgramOptimizationTuple(), NULL, ts);
    return ts;
  }
  
  clock_t rootbeg;
  if (problem->benchmark && node->isRoot()) rootbeg = clock();
  
  if (node->isRoot())
  {
    workingStatement = problem->curStatement().clone();
    originalStatementsVars = workingStatement->variables();
  }

  // first, make depth-first recursive calls. We want to do bottom-up traversal.
  vector<LogicProgramOptimizationTuple*> childPreds;
  for (list<Hypertree *>::const_iterator cit = node->getChildren()->begin(); cit != node->getChildren()->end(); ++cit)
    childPreds.push_back((LogicProgramOptimizationTuple *) evaluateNode((ExtendedHypertree*)*cit)->begin()->first);
  
  clock_t tmp_time;
  if (problem->benchmark) tmp_time = clock();

  // update width if needed (takes just biggest bag in the program)
  if (problem->width < node->getVertices().size())
    problem->width = node->getVertices().size();

  if (!node->isRoot())
  {
    // those body elements of the base rule that are in this node: (go in bodyPart)
    varset thisVars;
    for (VertexSet::iterator it = node->getVertices().begin(); it != node->getVertices().end(); ++it)
    {
      Variable* var = new Variable(new string(problem->getVertexName(*it)));
      thisVars.insert(var);
    }
    if (problem->benchmark) { bodyPart_time += clock() - tmp_time; tmp_time = clock(); }  
    vector<const BodyElement *>* bodyPart = workingStatement->extractBodyWithoutGlobvarUpdate(thisVars);
    if (problem->benchmark) { extractBody_time += clock() - tmp_time; tmp_time = clock(); }
    for (varset::iterator it = thisVars.begin(); it != thisVars.end(); ++it)
      delete *it;
    if (problem->benchmark) { bodyPart_time += clock() - tmp_time; tmp_time = clock(); }

    // create new rule body:
    Body* body = new Body();
    for (vector<const BodyElement *>::iterator it = bodyPart->begin(); it != bodyPart->end(); ++it)
      body->add((*it)->clone());
    delete bodyPart;
    set<string> taggedAlongHeadVars;
    for (vector<LogicProgramOptimizationTuple*>::iterator it = childPreds.begin(); it != childPreds.end(); ++it)
    {
      body->add((*it)->temporary);
      if (problem->ignoreHeadVariables)
      {
	taggedAlongHeadVars.insert((*it)->ignoreHeadTags.begin(), (*it)->ignoreHeadTags.end());
      }
      delete *it;
    }
    if (problem->benchmark) { bodyCreation_time += clock() - tmp_time; tmp_time = clock(); }

 
    // create temporary predicate:
    VertexSet intersectionVertices;
    std::set_intersection(node->getVertices().begin(), node->getVertices().end(), node->parent()->getVertices().begin(), node->parent()->getVertices().end(), inserter(intersectionVertices, intersectionVertices.begin()));
    set<Variable*, var_cmp> tmpPredVars;
    for (VertexSet::iterator it = intersectionVertices.begin(); it != intersectionVertices.end(); ++it)
    {
      tmpPredVars.insert(new Variable(new string(problem->getVertexName(*it))));
    }
    // if we ignored head variables while decomposing, include head variables intersecting with this node's vertices in intersection:
    if (problem->ignoreHeadVariables)
    {
      for (set<string>::iterator it = taggedAlongHeadVars.begin(); it != taggedAlongHeadVars.end(); ++it)
      {
	tmpPredVars.insert(new Variable(new string(*it)));
      }
      varset* headVars = problem->curStatement().headVars();
      for (VertexSet::iterator it = node->getVertices().begin(); it != node->getVertices().end(); ++it)
      {
	Variable* toCheck = new Variable(new string(problem->getVertexName(*it)));
	if (headVars->find(toCheck) != headVars->end()) // insert variable into tmpPredVars
	  if(!tmpPredVars.insert(toCheck).second)
	    delete toCheck;
	  else
	    taggedAlongHeadVars.insert(toCheck->getName());
	else
	  delete toCheck;
      }
      delete headVars;
    }

    ClassicalLiteral* tempPred;
    if (tmpPredVars.empty()) // no arguments in predicate / arity 0
      tempPred = new ClassicalLiteral(problem->gen->get(), false, false);
    else
    {
      vector<Term*>* tempPredTerms = new vector<Term*>(tmpPredVars.begin(), tmpPredVars.end());
      tempPred = new ClassicalLiteral(problem->gen->get(), false, false, new TermTuples(new vector<TermTuple *>(1, new TermTuple(tempPredTerms))));
    }
    if (problem->benchmark) { tempPredCreation_time += clock() - tmp_time; tmp_time = clock(); }
   
    
    // deal with unsafe variables:
    SafetyCharacterization* safety;
    while(!(safety = body->safety(*originalStatementsVars))->unsafeVars().empty())
    {
      // for each unsafe var, create new Rule and add the safety predicate to the body: TODO: wouldn't it be more efficient to generate only one safety predicate for all unsafe variables?
      // choose those variable first that cannot be made safe with the current body and recheck safety afterwards.
      varset* cands = safety->nonSafeable();
      const Variable* cand;
      if (!cands->empty()) cand = *(cands->begin());
      else cand = *(safety->unsafeVars().begin());
      vector<const BodyElement*>* safemakers = problem->curStatement().selectSafe(*cand);
      ClassicalLiteral* safetyPred = new ClassicalLiteral(&problem->gen->get()->append("_safe"), false, false, new TermTuples(new vector<TermTuple *>(1, new TermTuple(new vector<Term*>(1, new Variable(*cand))))));
      body->add(safetyPred);
      vector<BodyElement*>* bodyElements = new vector<BodyElement*>();
      for (vector<const BodyElement*>::iterator bit = safemakers->begin(); bit != safemakers->end(); ++bit)
	      bodyElements->push_back((*bit)->clone());
      problem->createdProgram->push_back(new Rule(new Disjunction(new vector<ClassicalLiteral*>(1, safetyPred->clone())), new Body(bodyElements))); // TODO: new safety rule may be split up as well!!!
      delete safemakers;
    }
    if (problem->benchmark) { unsafe_time += clock() - tmp_time; tmp_time = clock(); }    

    // make new rule:
    problem->createdProgram->push_back(new Rule(new Disjunction(new vector<ClassicalLiteral *>(1, tempPred->clone())), body));
    
    TupleSet *ts = new TupleSet();
    LogicProgramOptimizationTuple *t = new LogicProgramOptimizationTuple();
    t->temporary = tempPred;
    if (problem->ignoreHeadVariables)
      t->ignoreHeadTags = taggedAlongHeadVars;
    this->addToTupleSet(t, NULL, ts);
    if (problem->benchmark) { rest_time += clock() - tmp_time; }    
    return ts;
  }
  else // node is root node
  {
    // since we used extractBodyWithoutGlobvarUpdate:
    workingStatement->calcVariables();
    // now, workingStatement consists only of variable-free body elements and the original head.
    // since we are in head node, there are no unsafes in our body.
    // add the temps to the body, then we are finished:
    for (vector<LogicProgramOptimizationTuple*>::iterator it = childPreds.begin(); it != childPreds.end(); ++it)
    {
      workingStatement->addToBody((*it)->temporary);
      delete *it;
    }

    problem->createdProgram->push_back(workingStatement);
    
    TupleSet *ts = new TupleSet();
    this->addToTupleSet(new LogicProgramOptimizationTuple(), NULL, ts);

    if (problem->benchmark)
    {
      rest_time += clock() - tmp_time;
      cout << "\t\t" << (float) (clock() - rootbeg) / CLOCKS_PER_SEC << " seconds for final solution calculation based on decomp for statement " << problem->currentStatement << ". (finished)" << endl;
    }

    return ts;
  }
}
  
void LogicProgramOptimizationAlgorithm::printBenchmarks() const
{
  if (problem->benchmark)
    cout << "\t\t\tseconds for final solution calculation based on decomp, split up into bodyPart_time, extractBody_time, bodyCreation_time, tempPredCreation_time, unsafe_time, rest_time: "
      << (float) (bodyPart_time) / CLOCKS_PER_SEC << ", " << (float) (extractBody_time) / CLOCKS_PER_SEC << ", " << (float) (bodyCreation_time) / CLOCKS_PER_SEC << ", " << (float) (tempPredCreation_time) / CLOCKS_PER_SEC << ", " << (float) (unsafe_time) / CLOCKS_PER_SEC << ", " << (float) (rest_time) / CLOCKS_PER_SEC << endl;
}
